unit CEMediaInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CEMediaInfoCommon, CEWaveInfo, CEMidiInfo, CEAuxInfo, CEMixerInfo,
  CEJoyInfo, MMSystem;

type
  TCEMediaInfo = class(TComponent)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    WaveOutDevices  : TWaveOutDevices;
    WaveInDevices   : TWaveInDevices;
    MidiOutDevices  : TMidiOutDevices;
    MidiInDevices   : TMidiInDevices;
    AuxDevices      : TAuxDevices;
    MixerDevices    : TMixerDevices;
    JoyDevices      : TJoyDevices;

    constructor Create(AOwner : TComponent); override;
    destructor  Destroy; override;
  published
    { Published declarations }
  end;

procedure Register;

implementation
//================== TCEMediaInfo ===================//
constructor TCEMediaInfo.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  WaveOutDevices:=TWaveOutDevices.Create;
  WaveInDevices:=TWaveInDevices.Create;
  MidiOutDevices:=TMidiOutDevices.Create;
  MidiInDevices:=TMidiInDevices.Create;
  AuxDevices:=TAuxDevices.Create;
  MixerDevices:=TMixerDevices.Create;
  JoyDevices:=TJoyDevices.Create;
end;

destructor TCEMediaInfo.Destroy;
begin
  JoyDevices.Free;
  MixerDevices.Free;
  AuxDevices.Free;
  MidiInDevices.Free;
  MidiOutDevices.Free;
  WaveInDevices.Free;
  WaveOutDevices.Free;
  inherited Destroy;
end;


procedure Register;
begin
  RegisterComponents('CESystem', [TCEMediaInfo]);
end;

end.
