unit CEMediaInfoCommon;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MMSystem;

const
  MM_MICROSOFT                 = 1;         
  MM_CREATIVE                  = 2;         
  MM_MEDIAVISION               = 3;         
  MM_FUJITSU                   = 4;         
  MM_PRAGMATRAX                = 5;         
  MM_CYRIX                     = 6;         
  MM_PHILIPS_SPEECH_PROCESSING = 7;         
  MM_NETXL                     = 8;         
  MM_ZYXEL                     = 9;         
  MM_BECUBED                   = 10;        
  MM_AARDVARK                  = 11;        
  MM_BINTEC                    = 12;        
  MM_HEWLETT_PACKARD           = 13;        
  MM_ACULAB                    = 14;        
  MM_FAITH                     = 15;        
  MM_MITEL                     = 16;        
  MM_QUANTUM3D                 = 17;        
  MM_SNI                       = 18;        
  MM_EMU                       = 19;        
  MM_ARTISOFT                  = 20;        
  MM_TURTLE_BEACH              = 21;        
  MM_IBM                       = 22;        
  MM_VOCALTEC                  = 23;        
  MM_ROLAND                    = 24;        
  MM_DSP_SOLUTIONS             = 25;        
  MM_NEC                       = 26;        
  MM_ATI                       = 27;        
  MM_WANGLABS                  = 28;        
  MM_TANDY                     = 29;        
  MM_VOYETRA                   = 30;        
  MM_ANTEX                     = 31;        
  MM_ICL_PS                    = 32;        
  MM_INTEL                     = 33;        
  MM_GRAVIS                    = 34;        
  MM_VAL                       = 35;        
  MM_INTERACTIVE               = 36;        
  MM_YAMAHA                    = 37;        
  MM_EVEREX                    = 38;        
  MM_ECHO                      = 39;        
  MM_SIERRA                    = 40;        
  MM_CAT                       = 41;        
  MM_APPS                      = 42;        
  MM_DSP_GROUP                 = 43;        
  MM_MELABS                    = 44;        
  MM_COMPUTER_FRIENDS          = 45;        
  MM_ESS                       = 46;        
  MM_AUDIOFILE                 = 47;        
  MM_MOTOROLA                  = 48;        
  MM_CANOPUS                   = 49;        
  MM_EPSON                     = 50;        
  MM_TRUEVISION                = 51;        
  MM_AZTECH                    = 52;        
  MM_VIDEOLOGIC                = 53;        
  MM_SCALACS                   = 54;        
  MM_KORG                      = 55;        
  MM_APT                       = 56;        
  MM_ICS                       = 57;        
  MM_ITERATEDSYS               = 58;        
  MM_METHEUS                   = 59;        
  MM_LOGITECH                  = 60;        
  MM_WINNOV                    = 61;        
  MM_NCR                       = 62;        
  MM_EXAN                      = 63;        
  MM_AST                       = 64;        
  MM_WILLOWPOND                = 65;        
  MM_SONICFOUNDRY              = 66;        
  MM_VITEC                     = 67;        
  MM_MOSCOM                    = 68;        
  MM_SILICONSOFT               = 69;        
  MM_TERRATEC                  = 70;        
  MM_MEDIASONIC                = 71;        
  MM_SANYO                     = 72;        
  MM_SUPERMAC                  = 73;        
  MM_AUDIOPT                   = 74;        
  MM_NOGATECH                  = 75;        
  MM_SPEECHCOMP                = 76;        
  MM_AHEAD                     = 77;        
  MM_DOLBY                     = 78;        
  MM_OKI                       = 79;        
  MM_AURAVISION                = 80;        
  MM_OLIVETTI                  = 81;        
  MM_IOMAGIC                   = 82;        
  MM_MATSUSHITA                = 83;        
  MM_CONTROLRES                = 84;        
  MM_XEBEC                     = 85;        
  MM_NEWMEDIA                  = 86;        
  MM_NMS                       = 87;        
  MM_LYRRUS                    = 88;        
  MM_COMPUSIC                  = 89;        
  MM_OPTI                      = 90;        
  MM_ADLACC                    = 91;        
  MM_COMPAQ                    = 92;        
  MM_DIALOGIC                  = 93;        
  MM_INSOFT                    = 94;        
  MM_MPTUS                     = 95;        
  MM_WEITEK                    = 96;        
  MM_LERNOUT_AND_HAUSPIE       = 97;        
  MM_QCIAR                     = 98;        
  MM_APPLE                     = 99;        
  MM_DIGITAL                   = 100;       
  MM_MOTU                      = 101;       
  MM_WORKBIT                   = 102;       
  MM_OSITECH                   = 103;       
  MM_MIRO                      = 104;       
  MM_CIRRUSLOGIC               = 105;       
  MM_ISOLUTION                 = 106;       
  MM_HORIZONS                  = 107;       
  MM_CONCEPTS                  = 108;       
  MM_VTG                       = 109;       
  MM_RADIUS                    = 110;       
  MM_ROCKWELL                  = 111;       
  MM_XYZ                       = 112;       
  MM_OPCODE                    = 113;       
  MM_VOXWARE                   = 114;       
  MM_NORTHERN_TELECOM          = 115;       
  MM_APICOM                    = 116;       
  MM_GRANDE                    = 117;       
  MM_ADDX                      = 118;       
  MM_WILDCAT                   = 119;       
  MM_RHETOREX                  = 120;       
  MM_BROOKTREE                 = 121;       
  MM_RESERV_01                 = 122;
  MM_RESERV_02                 = 123;
  MM_RESERV_03                 = 124;
  MM_ENSONIQ                   = 125;       
  MM_FAST                      = 126;       
  MM_NVIDIA                    = 127;       
  MM_OKSORI                    = 128;       
  MM_DIACOUSTICS               = 129;       
  MM_GULBRANSEN                = 130;       
  MM_KAY_ELEMETRICS            = 131;       
  MM_CRYSTAL                   = 132;       
  MM_SPLASH_STUDIOS            = 133;       
  MM_QUARTERDECK               = 134;       
  MM_TDK                       = 135;       
  MM_DIGITAL_AUDIO_LABS        = 136;       
  MM_SEERSYS                   = 137;       
  MM_PICTURETEL                = 138;       
  MM_ATT_MICROELECTRONICS      = 139;       
  MM_OSPREY                    = 140;       
  MM_MEDIATRIX                 = 141;       
  MM_SOUNDESIGNS               = 142;       
  MM_ALDIGITAL                 = 143;       
  MM_SPECTRUM_SIGNAL_PROCESSING= 144;       
  MM_ECS                       = 145;       
  MM_AMD                       = 146;       
  MM_COREDYNAMICS              = 147;       
  MM_CANAM                     = 148;       
  MM_SOFTSOUND                 = 149;       
  MM_NORRIS                    = 150;       
  MM_DDD                       = 151;       
  MM_EUPHONICS                 = 152;       
  MM_PRECEPT                   = 153;       
  MM_CRYSTAL_NET               = 154;       
  MM_CHROMATIC                 = 155;       
  MM_VOICEINFO                 = 156;       
  MM_VIENNASYS                 = 157;       
  MM_CONNECTIX                 = 158;       
  MM_GADGETLABS                = 159;       
  MM_FRONTIER                  = 160;       
  MM_VIONA                     = 161;       
  MM_CASIO                     = 162;       
  MM_DIAMONDMM                 = 163;       
  MM_S3                        = 164;       
  MM_DVISION                   = 165;       
  MM_NETSCAPE                  = 166;       
  MM_SOUNDSPACE                = 167;       
  MM_VANKOEVERING              = 168;       
  MM_QTEAM                     = 169;       
  MM_ZEFIRO                    = 170;       
  MM_STUDER                    = 171;       
  MM_FRAUNHOFER_IIS            = 172;       
  MM_QUICKNET                  = 173;       
  MM_ALARIS                    = 174;       
  MM_SICRESOURCE               = 175;       
  MM_NEOMAGIC                  = 176;       
  MM_MERGING_TECHNOLOGIES      = 177;       
  MM_XIRLINK                   = 178;       
  MM_COLORGRAPH                = 179;       
  MM_OTI                       = 180;       
  MM_AUREAL                    = 181;       
  MM_VIVO                      = 182;       
  MM_SHARP                     = 183;       
  MM_LUCENT                    = 184;       
  MM_ATT                       = 185;       
  MM_SUNCOM                    = 186;       
  MM_SORVIS                    = 187;       
  MM_INVISION                  = 188;       
  MM_BERKOM                    = 189;       
  MM_MARIAN                    = 190;       
  MM_DPSINC                    = 191;       
  MM_BCB                       = 192;       
  MM_MOTIONPIXELS              = 193;       
  MM_QDESIGN                   = 194;       
  MM_NMP                       = 195;       
  MM_DATAFUSION                = 196;       
  MM_DUCK                      = 197;       
  MM_FTR                       = 198;       
  MM_BERCOS                    = 199;       
  MM_ONLIVE                    = 200;       
  MM_SIEMENS_SBC               = 201;       
  MM_TERALOGIC                 = 202;       
  MM_PHONET                    = 203;       
  MM_WINBOND                   = 204;       
  MM_VIRTUALMUSIC              = 205;       
  MM_ENET                      = 206;       
  MM_GUILLEMOT                 = 207;       
  MM_EMAGIC                    = 208;       
  MM_MWM                       = 209;       
  MM_PACIFICRESEARCH           = 210;       
  MM_SIPROLAB                  = 211;       
  MM_LYNX                      = 212;       
  MM_SPECTRUM_PRODUCTIONS      = 213;       
  MM_DICTAPHONE                = 214;       
  MM_QUALCOMM                  = 215;       
  MM_RZS                       = 216;       
  MM_AUDIOSCIENCE              = 217;       
  MM_PINNACLE                  = 218;       
  MM_EES                       = 219;       
  MM_HAFTMANN                  = 220;       
  MM_LUCID                     = 221;       
  MM_HEADSPACE                 = 222;       
  MM_UNISYS                    = 223;       
  MM_LUMINOSITI                = 224;       
  MM_ACTIVEVOICE               = 225;       
  MM_DTS                       = 226;       
  MM_DIGIGRAM                  = 227;       
  MM_SOFTLAB_NSK               = 228;       
  MM_FORTEMEDIA                = 229;       
  MM_SONORUS                   = 230;       
  MM_ARRAY                     = 231;       
  MM_DATARAN                   = 232;       
  MM_I_LINK                    = 233;       
  MM_SELSIUS_SYSTEMS           = 234;       
  MM_ADMOS                     = 235;       
  MM_LEXICON                   = 236;       
  MM_SGI                       = 237;       
  MM_IPI                       = 238;       
  MM_ICE                       = 239;       
  MM_VQST                      = 240;       
  MM_ETEK                      = 241;       
  MM_CS                        = 242;       
  MM_ALESIS                    = 243;       
  MM_INTERNET                  = 244;       
  MM_SONY                      = 245;       
  MM_HYPERACTIVE               = 246;       
  MM_UHER_INFORMATIC           = 247;       
  MM_SYDEC_NV                  = 248;       
  MM_FLEXION                   = 249;       
  MM_VIA                       = 250;       
  MM_MICRONAS                  = 251;       
  MM_ANALOGDEVICES             = 252;       
  MM_HP                        = 253;       
  MM_MATROX_DIV                = 254;       
  MM_QUICKAUDIO                = 255;       
  MM_YOUCOM                    = 256;       
  MM_RICHMOND                  = 257;       
  MM_IODD                      = 258;       
  MM_ICCC                      = 259;       
  MM_3COM                      = 260;
  MM_MALDEN                    = 261;

  VendorNameString : array[MM_MICROSOFT..MM_MALDEN] of string = (
  'Microsoft Corporation',
  'Creative Labs, Inc.',
  'Media Vision, Inc.',
  'Fujitsu Corp.',
  'PRAGMATRAX Software',
  'Cyrix Corporation',
  'Philips Speech Processing',
  'NetXL, Inc.',
  'ZyXEL Communications, Inc.',
  'BeCubed Software Inc.',
  'Aardvark Computer Systems, Inc.',
  'Bin Tec Communications GmbH',
  'Hewlett-Packard Company',
  'Aculab plc',
  'Faith,Inc.',
  'Mitel Corporation',
  'Quantum3D, Inc.',
  'Siemens-Nixdorf',
  'E-mu Systems, Inc.',
  'Artisoft, Inc.',
  'Turtle Beach, Inc.',
  'IBM Corporation',
  'Vocaltec Ltd.',
  'Roland',
  'DSP Solutions, Inc.',
  'NEC',
  'ATI Technologies Inc.',
  'Wang Laboratories, Inc.',
  'Tandy Corporation',
  'Voyetra',
  'Antex Electronics Corporation',
  'ICL Personal Systems',
  'Intel Corporation',
  'Advanced Gravis',
  'Video Associates Labs, Inc.',
  'InterActive Inc.',
  'Yamaha Corporation of America',
  'Everex Systems, Inc.',
  'Echo Speech Corporation',
  'Sierra Semiconductor Corp',
  'Computer Aided Technologies',
  'APPS Software International',
  'DSP Group, Inc.',
  'microEngineering Labs',
  'Computer Friends, Inc.',
  'ESS Technology',
  'Audio, Inc.',
  'Motorola, Inc.',
  'Canopus, co., Ltd.',
  'Seiko Epson Corporation',
  'Truevision',
  'Aztech Labs, Inc.',
  'Videologic',
  'SCALACS',
  'Korg Inc.',
  'Audio Processing Technology',
  'Integrated Circuit Systems, Inc.',
  'Iterated Systems, Inc.',
  'Metheus',
  'Logitech, Inc.',
  'Winnov, Inc.',
  'NCR Corporation',
  'EXAN',
  'AST Research Inc.',
  'Willow Pond Corporation',
  'Sonic Foundry',
  'Vitec Multimedia',
  'MOSCOM Corporation',
  'Silicon Soft, Inc.',
  'TerraTec Electronic GmbH',
  'MediaSonic Ltd.',
  'SANYO Electric Co., Ltd.',
  'Supermac',
  'Audio Processing Technology',
  'NOGATECH Ltd.',
  'Speech Compression',
  'Ahead, Inc.',
  'Dolby Laboratories',
  'OKI',
  'AuraVision Corporation',
  'Ing C. Olivetti & C., S.p.A.',
  'I/O Magic Corporation',
  'Matsushita Electric Industrial Co., Ltd.',
  'Control Resources Limited',
  'Xebec Multimedia Solutions Limited',
  'New Media Corporation',
  'Natural MicroSystems',
  'Lyrrus Inc.',
  'Compusic',
  'OPTi Computers Inc.',
  'Adlib Accessories Inc.',
  'Compaq Computer Corp.',
  'Dialogic Corporation',
  'InSoft, Inc.',
  'M.P. Technologies, Inc.',
  'Weitek',
  'Lernout & Hauspie',
  'Quanta Computer Inc.',
  'Apple Computer, Inc.',
  'Digital Equipment Corporation',
  'Mark of the Unicorn',
  'Workbit Corporation',
  'Ositech Communications Inc.',
  'miro Computer Products AG',
  'Cirrus Logic',
  'ISOLUTION  B.V.',
  'Horizons Technology, Inc.',
  'Computer Concepts Ltd.',
  'Voice Technologies Group, Inc.',
  'Radius',
  'Rockwell International',
  'Co. XYZ for testing',
  'Opcode Systems',
  'Voxware Inc.',
  'Northern Telecom Limited',
  'APICOM',
  'Grande Software',
  'ADDX',
  'Wildcat Canyon Software',
  'Rhetorex Inc.',
  'Brooktree Corporation',
  'Unknown Vendor',
  'Unknown Vendor',
  'Unknown Vendor',
  'ENSONIQ Corporation',
  'FAST Multimedia AG',
  'NVidia Corporation',
  'OKSORI Co., Ltd.',
  'DiAcoustics, Inc.',
  'Gulbransen, Inc.',
  'Kay Elemetrics, Inc.',
  'Crystal Semiconductor Corporation',
  'Splash Studios',
  'Quarterdeck Corporation',
  'TDK Corporation',
  'Digital Audio Labs, Inc.',
  'Seer Systems, Inc.',
  'PictureTel Corporation',
  'AT&T Microelectronics',
  'Osprey Technologies, Inc.',
  'Mediatrix Peripherals',
  'SounDesignS M.C.S. Ltd.',
  'A.L. Digital Ltd.',
  'Spectrum Signal Processing, Inc.',
  'Electronic Courseware Systems, Inc.',
  'AMD',
  'Core Dynamics',
  'CANAM Computers',
  'Softsound, Ltd.',
  'Norris Communications, Inc.',
  'Danka Data Devices',
  'EuPhonics',
  'Precept Software, Inc.',
  'Crystal Net Corporation',
  'Chromatic Research, Inc.',
  'Voice Information Systems, Inc.',
  'Vienna Systems',
  'Connectix Corporation',
  'Gadget Labs LLC',
  'Frontier Design Group LLC',
  'Viona Development GmbH',
  'Casio Computer Co., LTD',
  'Diamond Multimedia',
  'S3',
  'D-Vision Systems, Inc.',
  'Netscape Communications',
  'Soundspace Audio',
  'VanKoevering Company',
  'Q-Team',
  'Zefiro Acoustics',
  'Studer Professional Audio AG',
  'Fraunhofer IIS',
  'Quicknet Technologies',
  'Alaris, Inc.',
  'SIC Resource Inc.',
  'NeoMagic Corporation',
  'Merging Technologies S.A.',
  'Xirlink, Inc.',
  'Colorgraph (UK) Ltd',
  'Oak Technology, Inc.',
  'Aureal Semiconductor',
  'Vivo Software',
  'Sharp',
  'Lucent Technologies',
  'AT&T Labs, Inc.',
  'Sun Communications, Inc.',
  'Sorenson Vision',
  'InVision Interactive',
  'Deutsche Telekom Berkom GmbH',
  'Marian GbR Leipzig',
  'Digital Processing Systems, Inc.',
  'BCB Holdings Inc.',
  'Motion Pixels',
  'QDesign Corporation',
  'Nokia Mobile Phones',
  'DataFusion Systems (Pty) (Ltd)',
  'The Duck Corporation',
  'Future Technology Resources Pty Ltd',
  'BERCOS GmbH',
  'OnLive! Technologies, Inc.',
  'Siemens Business Communications Systems',
  'TeraLogic, Inc.',
  'PhoNet Communications Ltd.',
  'Winbond Electronics Corp',
  'Virtual Music, Inc.',
  'e-Net, Inc.',
  'Guillemot International',
  'Emagic Soft- und Hardware GmbH',
  'MWM Acoustics LLC',
  'Pacific Research and Engineering Corporation',
  'Sipro Lab Telecom Inc.',
  'Lynx Studio Technology, Inc.',
  'Spectrum Productions',
  'Dictaphone Corporation',
  'QUALCOMM, Inc.',
  'Ring Zero Systems, Inc',
  'AudioScience Inc.',
  'Pinnacle Systems, Inc.',
  'EES Technik fr Musik GmbH',
  'haftmann#software',
  'Lucid Technology, Symetrix Inc.',
  'Headspace, Inc',
  'UNISYS CORPORATION',
  'Luminositi, Inc.',
  'ACTIVE VOICE CORPORATION',
  'Digital Theater Systems, Inc.',
  'DIGIGRAM',
  'Softlab-Nsk',
  'ForteMedia, Inc',
  'Sonorus, Inc.',
  'Array Microsystems, Inc.',
  'Data Translation, Inc.',
  'I-link Worldwide',
  'Selsius Systems Inc.',
  'AdMOS Technology, Inc.',
  'Lexicon Inc.',
  'Silicon Graphics Inc.',
  'Interactive Product Inc.',
  'IC Ensemble, Inc.',
  'ViewQuest Technologies Inc.',
  'eTEK Labs Inc.',
  'Consistent Software',
  'Alesis Studio Electronics',
  'INTERNET Corporation',
  'Sony Corporation',
  'Hyperactive Audio Systems, Inc.',
  'UHER informatic GmbH',
  'Sydec NV',
  'Flexion Systems Ltd.',
  'Via Technologies, Inc.',
  'Micronas Semiconductors, Inc.',
  'Analog Devices, Inc.',
  'Hewlett Packard Company',
  'Matrox',
  'Quick Audio, GbR',
  'You/Com Audiocommunicatie BV',
  'Richmond Sound Design Ltd.',
  'I-O Data Device, Inc.',
  'ICCC A/S',
  '3COM Corporation',
  'Malden Electronics Ltd.'
  );




type
  TFeature = record
    FName   : WideString;
    FValue  : boolean;
  end;

function DecodeVendorName(AVendorID : word) : string;

implementation

function DecodeVendorName(AVendorID : word) : string;
begin
  Result:='Unknown Vendor';
  if AVendorID<=MM_MALDEN then
    Result:=VendorNameString[AVendorID];
end;

end.
